#include "loquet.h"
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#define NB_LOQUETS 3
#define NB_THREADS_ATTENTE_LOQUET 5

loquet_t loquet;

void *threadDecrementLoquet(void *arg){
  int i, rc;
  printf("threadDecrementLoquet demarre !\n");
  for (i = 0; i < NB_LOQUETS; i++) {
    sleep(1);
    rc = decrementLoquet(&loquet);
    printf("threadDecrementLoquet a appele decrementLoquet() (rc = %d, encore %d appels)\n", rc, NB_LOQUETS - i - 1);
  }
  printf("threadDecrementLoquet termine !\n");
  pthread_exit(NULL);
}

void *threadAttenteLoquet(void *arg){
  int numThread = (int)arg;
  int rc;
  printf("threadAttenteLoquet %d appelle attenteLoquet()\n", numThread);
  rc = attenteLoquet(&loquet);
  printf("threadAttenteLoquet %d est sorti de attenteLoquet() (rc = %d)\n", numThread, rc);
  pthread_exit(NULL);
}

int main(){
  int i, rc;
  pthread_t thread[1+NB_THREADS_ATTENTE_LOQUET];

  rc = nouveauLoquet(&loquet, NB_LOQUETS);
  if (rc != 0) {
    perror("nouveauLoquet");
    exit(EXIT_FAILURE);
  }
  printf("nouveauLoquet() appele avec valeur %d en parametre\n", NB_LOQUETS);
  rc = pthread_create(&thread[0], NULL, threadDecrementLoquet, NULL);
  if (rc != 0){
    perror("pthread_create1");
    exit(EXIT_FAILURE);
  }
  printf("On demarre des threads threadAttenteLoquet alors que le loquet n'est pas passant\n");
  for (i = 0; i < NB_THREADS_ATTENTE_LOQUET; i++) {
    rc = pthread_create(&thread[1+i], NULL, threadAttenteLoquet, (void*)i);
    if (rc != 0){
      perror("pthread_create2");
      exit(EXIT_FAILURE);
    }
  }
  for (i = 0; i < 1+NB_THREADS_ATTENTE_LOQUET; i++) {
    rc = pthread_join(thread[i], NULL);
    if (rc != 0){
      perror("pthread_join");
      exit(EXIT_FAILURE);
    }
  }
  printf("On demarre des threads threadAttenteLoquet alors que le loquet est passant\n");
  for (i = 0; i < NB_THREADS_ATTENTE_LOQUET; i++) {
    rc = pthread_create(&thread[i], NULL, threadAttenteLoquet, (void*)i);
    if (rc != 0){
      perror("pthread_create2");
      exit(EXIT_FAILURE);
    }
  }
  for (i = 0; i < NB_THREADS_ATTENTE_LOQUET; i++) {
    rc = pthread_join(thread[i], NULL);
    if (rc != 0){
      perror("pthread_join");
      exit(EXIT_FAILURE);
    }
  }
  rc = destructionLoquet(&loquet);
  if (rc != 0){
    perror("destructionLoquet");
    exit(EXIT_FAILURE);
  }
  return EXIT_SUCCESS;
}
